#ifndef __IMMS_H
#define __IMMS_H

#include <string>
#include <fstream>
#include <list>
#include <id3/tag.h>

#include "sqldb.h"

#define FIRST_SKIP_RATE -8
#define CONS_SKIP_RATE -4
#define FIRST_NON_SKIP_RATE 6
#define JUMPED_FROM -1
#define JUMPED_TO_SKIPPED 1
#define JUMPED_TO_FINNISHED 8
#define CONS_NON_SKIP_RATE 2
#define INITIAL_RATING 100
#define THRESHOLD_GROW 0.35
#define THRESHOLD_DECAY 0.1
#define TIMEHOLD_PART 0.1
#define EXPONENT_STEP 4

#define BIAS 1

#define TERM_WIDTH 80

using namespace std;

enum Status
{
    play_ok = 0,
    dont_rate,
    do_skip,
    jump_random
};

class MyID3Tag : public ID3_Tag
{
public:
    string get_artist();
    string get_title();
};

class Imms
{
public:
    Imms();
    Status song_changed(const string &path, int time_left, bool jumped);
    void setup(const char* _email, const char* _logfile);

protected:
    void set_popm(int mod);
    int get_popm();

    ofstream fout;

    SqlDb sqldb;
    string email;
    double threshold, timehold;
    bool last_skipped, last_jumped;
    Status status;

    MyID3Tag id3tag;
};

#endif
